Solaris32AndSolaris64Test.sh revision 474
0N/A#!/bin/ksh -p
0N/A
0N/A#
0N/A# Copyright 2001-2006 Sun Microsystems, Inc. All Rights Reserved.
0N/A# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
0N/A#
0N/A# This code is free software; you can redistribute it and/or modify it
0N/A# under the terms of the GNU General Public License version 2 only, as
0N/A# published by the Free Software Foundation.
0N/A#
0N/A# This code is distributed in the hope that it will be useful, but WITHOUT
0N/A# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
0N/A# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
0N/A# version 2 for more details (a copy is included in the LICENSE file that
0N/A# accompanied this code).
0N/A#
0N/A# You should have received a copy of the GNU General Public License version
0N/A# 2 along with this work; if not, write to the Free Software Foundation,
0N/A# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
0N/A#
0N/A# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa Clara,
0N/A# CA 95054 USA or visit www.sun.com if you need additional information or
0N/A# have any questions.
0N/A#
0N/A
0N/A#
0N/A# @test Solaris32AndSolaris64Test.sh
474N/A# @bug 4478312 4780570 4913748 6730273
0N/A# @summary Test debugging with mixed 32/64bit VMs.
0N/A# @author Tim Bell
0N/A# Based on test/java/awt/TEMPLATE/AutomaticShellTest.sh
0N/A#
0N/A# @run build TestScaffold VMConnection TargetListener TargetAdapter
0N/A# @run compile -g FetchLocals.java
0N/A# @run compile -g DataModelTest.java
0N/A# @run shell/timeout=240 Solaris32AndSolaris64Test.sh DataModelTest
0N/A# @run shell/timeout=240 Solaris32AndSolaris64Test.sh FetchLocals
0N/A
0N/A# Beginning of subroutines:
0N/Astatus=1
0N/A
0N/A#Call this from anywhere to fail the test with an error message
0N/A# usage: fail "reason why the test failed"
0N/Afail()
0N/A { echo "The test failed :-("
0N/A echo "$*" 1>&2
0N/A echo "exit status was $status"
0N/A exit $status
0N/A } #end of fail()
0N/A
0N/A#Call this from anywhere to pass the test with a message
0N/A# usage: pass "reason why the test passed if applicable"
0N/Apass()
0N/A { echo "The test passed!!!"
0N/A echo "$*" 1>&2
0N/A exit 0
0N/A } #end of pass()
0N/A
0N/A# end of subroutines
0N/A
0N/Aif [ $# = 0 ] ; then
0N/A echo "Error: no testname specified on cmd line"
0N/A exit 1
0N/Afi
0N/AtestName=$1
0N/Ashift
0N/A
0N/A#Set appropriate jdk
0N/A
0N/Aif [ -z "${TESTJAVA}" ] ; then
0N/A # TESTJAVA is not set, so the test is running stand-alone.
0N/A # TESTJAVA holds the path to the root directory of the build of the JDK
0N/A # to be tested. That is, any java files run explicitly in this shell
0N/A # should use TESTJAVA in the path to the java interpreter.
0N/A # So, we'll set this to the JDK spec'd on the command line. If none
0N/A # is given on the command line, tell the user that and use a default.
0N/A # THIS IS THE JDK BEING TESTED.
0N/A if [ -n "$1" ] ; then
0N/A TESTJAVA=$1
0N/A else
0N/A echo "no JDK specified on command line so using JAVA_HOME=$JAVA_HOME"
0N/A TESTJAVA=$JAVA_HOME
0N/A fi
0N/A TESTSRC=.
0N/A TESTCLASSES=.
0N/A STANDALONE=1;
0N/Afi
0N/Aecho "JDK under test is: $TESTJAVA"
0N/A
0N/A
0N/A# The beginning of the script proper
0N/A
0N/A# Checking for proper OS and processor type.
0N/A#
0N/A# This test is only interested in SunOS SPARC sparcv9 and SunOS AMD64
0N/A# (supporting both 32 and 64 bit Solaris binaries).
0N/A#
0N/A# All other platforms will instantly complete with passing
0N/A# status.
0N/A#
0N/AOS=`uname -s`
0N/Acase "$OS" in
0N/A SunOS )
0N/A PATHSEP=":"
0N/A PTYPE=`uname -p`
0N/A if [ -x /usr/bin/isainfo ]; then
0N/A # Instruction set being used by the OS
0N/A ISET=`isainfo -k`
0N/A else
0N/A #SunOS 5.6 didn't have "isainfo"
0N/A pass "This test always passes on $OS/$PTYPE (32-bit ${ISET})"
0N/A fi
0N/A ;;
0N/A
0N/A Linux )
0N/A pass "This test always passes on $OS"
0N/A ;;
0N/A
0N/A Windows* | CYGWIN*)
0N/A pass "This test always passes on $OS"
0N/A ;;
0N/A
0N/A # catch all other OSs
0N/A * )
0N/A echo "Unrecognized system! $OS"
0N/A fail "Unrecognized system! $OS"
0N/A ;;
0N/Aesac
0N/A
0N/A# Is the OS running in sparcv9 or amd64 mode?
0N/Acase "${ISET}" in
0N/A sparc )
0N/A pass "This test always passes on $OS/$PTYPE (32-bit ${ISET})"
0N/A ;;
0N/A i386 )
0N/A pass "This test always passes on $OS/$PTYPE (32-bit ${ISET})"
0N/A ;;
0N/A amd64 )
0N/A echo "OS is running in ${ISET} mode"
0N/A ;;
0N/A sparcv9 )
0N/A echo "OS is running in ${ISET} mode"
0N/A ;;
0N/A # catch all others
0N/A * )
0N/A echo "Unrecognized instruction set! $OS/$PTYPE/${ISET}"
0N/A fail "Unrecognized instruction set! $OS/$PTYPE/${ISET}"
0N/A ;;
0N/Aesac
0N/A
0N/A# SunOS 32 and 64 bit binaries must be available
0N/A# to test in the remainder of the script below.
0N/A$TESTJAVA/bin/java -d64 -version > /dev/null 2<&1
0N/Aif [ $? = 1 ]; then
0N/A # The 64 bit version is not installed. Make the test pass.
0N/A pass "This test always passes on $OS/$PTYPE if 64 bit jdk is not installed"
0N/Afi
0N/A
0N/A# Want this test to run standalone as well as in the harness, so do the
0N/A# following to copy the test's directory into the harness's scratch directory
0N/A# and set all appropriate variables:
0N/A
0N/A#Deal with .class files:
0N/Aif [ -n "${STANDALONE}" ] ; then
0N/A #if running standalone, compile the support files
0N/A ${TESTJAVA}/bin/javac -d ${TESTCLASSES} \
0N/A -classpath "$TESTJAVA/lib/tools.jar${PATHSEP}." \
0N/A TestScaffold.java VMConnection.java TargetListener.java TargetAdapter.java
0N/A ${TESTJAVA}/bin/javac -d ${TESTCLASSES} \
0N/A -classpath "$TESTJAVA/lib/tools.jar${PATHSEP}." -g \
0N/A FetchLocals.java DataModelTest.java
0N/Afi
0N/A
0N/A# Get DEBUGGEE flags
0N/ADEBUGGEEFLAGS=
0N/Afilename=$TESTCLASSES/@debuggeeVMOptions
0N/Aif [ ! -r ${filename} ] ; then
0N/A filename=$TESTCLASSES/../@debuggeeVMOptions
0N/Afi
474N/A# Remove -d32, -d64 if present, and remove -XX:[+-]UseCompressedOops
474N/A# if present since it is illegal in 32 bit mode.
0N/Aif [ -r ${filename} ] ; then
474N/A DEBUGGEEFLAGS=`cat ${filename} | sed \
474N/A -e 's/-d32//g' \
474N/A -e 's/-d64//g' \
474N/A -e 's/-XX:.UseCompressedOops//g' \
474N/A `
0N/Afi
0N/A
0N/A#
0N/ACLASSPATH="$TESTJAVA/lib/tools.jar${PATHSEP}${TESTCLASSES}"
0N/Aexport CLASSPATH
0N/ACP="-classpath \"${CLASSPATH}\""
0N/A
0N/Afor DEBUGGERMODEL in \
0N/A 32 \
0N/A 64 \
0N/A; do
0N/A
0N/A for TARGETMODEL in \
0N/A 32 \
0N/A 64 \
0N/A ; do
0N/A DEBUGGERFLAGS="-d${DEBUGGERMODEL} -showversion -DEXPECTED=${TARGETMODEL}"
0N/A CONNECTSTRING="-connect 'com.sun.jdi.CommandLineLaunch:options=-d${TARGETMODEL} $DEBUGGEEFLAGS -showversion'"
0N/A
0N/A for TARGETCLASS in $testName ; do
0N/A echo "--------------------------------------------"
0N/A echo "debugger=${DEBUGGERMODEL} debugee=${TARGETMODEL} class=${TARGETCLASS}"
0N/A echo "--------------------------------------------"
0N/A echo ${TESTJAVA}/bin/java -DHANGINGJAVA_DEB ${DEBUGGERFLAGS} ${CP} ${TARGETCLASS} ${CONNECTSTRING}
0N/A eval ${TESTJAVA}/bin/java -DHANGINGJAVA_DEB ${DEBUGGERFLAGS} ${CP} ${TARGETCLASS} ${CONNECTSTRING}
0N/A status=$?
0N/A if [ $status -ne "0" ];
0N/A then fail "$DEBUGGERMODEL to $TARGETMODEL test failed for class=$TARGETCLASS!"
0N/A fi
0N/A done
0N/A done
0N/Adone
0N/A#
0N/A# pass or fail the test based on status of the command
0N/Aif [ $status -eq "0" ];
0N/A then pass ""
0N/A
0N/A else fail "unspecified test failure"
0N/Afi